//Class used for storing data of the current user 

int threshold1 = 1000; // threshold for incorrect data test received by kinect.
int threshold2 = 25; // threshold for data display in canvas

public class UserTrackingInfo {
    public ArrayList<PVector> positions;
    public PVector colour;
    private PVector lastP;

    public UserTrackingInfo() {
        positions = new ArrayList<PVector>();
        positions.add(new PVector(0,0,0));
        lastP = positions.get(positions.size() - 1);
        colour = new PVector(random(0, 255), random(0, 255), random(0, 255));
    }
    
    public void update(PVector currentP){
        lastP = positions.get(positions.size()-1);
        if(currentP.x==0 && currentP.y ==0 && currentP.z ==0 ){
          return;
        }
        if(positions.size() == 1){
            positions.add(currentP);
        }else{
            if((!this.isDumb(currentP)) && this.isFarEnough(currentP) ){
                positions.add(currentP);
            }
        }
    }
    
    private boolean isDumb(PVector currentP){
        if(abs(currentP.x - lastP.x) > threshold1){
            return true;
        } else if(abs(currentP.y - lastP.y) > threshold1){
            return true;
        } else if(abs(currentP.z - lastP.z) > threshold1){
            return true;
        } else return false;
    }
    
    private boolean isFarEnough(PVector currentP){
        float displacement = v_dist(currentP, lastP);
        if(displacement >=  threshold2) return true;
        else return false;
    }
      
      
};
